<html>
<head>
<title>Ogre::LayerBlendModeEx Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1LayerBlendModeEx.html">LayerBlendModeEx</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::LayerBlendModeEx Class Reference<div class="ingroups"><a class="el" href="group__Materials.html">Materials</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::LayerBlendModeEx" -->
<p>Class which manages blending of both colour and alpha components.  
 <a href="classOgre_1_1LayerBlendModeEx.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>&gt;</code></p>

<p><a href="classOgre_1_1LayerBlendModeEx-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#a4c678a65c3a32728622812d2784c2e6d">operator==</a> (const <a class="el" href="classOgre_1_1LayerBlendModeEx.html">LayerBlendModeEx</a> &amp;rhs) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#a1ea4fff299261c723f025337c513dc88">operator!=</a> (const <a class="el" href="classOgre_1_1LayerBlendModeEx.html">LayerBlendModeEx</a> &amp;rhs) const </td></tr>
<tr><td colspan="2"><h2><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Materials.html#ga1ae5925d36df27a6c3590536752264f8">LayerBlendType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#ac2cb8de7b805400726882f7003a4bcda">blendType</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The type of blending (colour or alpha)  <a href="#ac2cb8de7b805400726882f7003a4bcda"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Materials.html#ga264ecab38a04d01e2c3158fa05ec1ee2">LayerBlendOperationEx</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#afc151f1c17683cd99df776459df2c778">operation</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The operation to be applied.  <a href="#afc151f1c17683cd99df776459df2c778"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Materials.html#gae2ad78de344f35307ce35157c175625e">LayerBlendSource</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#a334818129ca44c1fbdba2b3b2813368a">source1</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The first source of colour/alpha.  <a href="#a334818129ca44c1fbdba2b3b2813368a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Materials.html#gae2ad78de344f35307ce35157c175625e">LayerBlendSource</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#a94eeae80ba84e9aa5271d317d48f2688">source2</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The second source of colour/alpha.  <a href="#a94eeae80ba84e9aa5271d317d48f2688"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1ColourValue.html">ColourValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#a99adb8004759bf3825d934684ab8f171">colourArg1</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Manual colour value for manual source1.  <a href="#a99adb8004759bf3825d934684ab8f171"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1ColourValue.html">ColourValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#a6bd40927e40bcb2d6c4e077ebd56c24d">colourArg2</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Manual colour value for manual source2.  <a href="#a6bd40927e40bcb2d6c4e077ebd56c24d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#a8af3aad5d2de939d0d9bff3049c82928">alphaArg1</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Manual alpha value for manual source1.  <a href="#a8af3aad5d2de939d0d9bff3049c82928"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#a9dde2b63904e61319b175094f8fc67f0">alphaArg2</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Manual alpha value for manual source2.  <a href="#a9dde2b63904e61319b175094f8fc67f0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1LayerBlendModeEx.html#a71cee0ade264a82051913d5eb0fc4c40">factor</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Manual blending factor.  <a href="#a71cee0ade264a82051913d5eb0fc4c40"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Class which manages blending of both colour and alpha components. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This class is a utility class used by both <a class="el" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a> and <a class="el" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a> to wrap up the details of a blending operation. This blending operation could be used for blending colour or alpha in a texture layer. This class is really only for use by OGRE, since apps can deal with blending modes through the <a class="el" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a> class methods setColourOperation and setAlphaOperation. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>It's worth noting that these operations are for blending <em>between texture layers</em> and not between rendered objects and the existing scene. If you wish to make an object blend with others in the scene, e.g. to make transparent objects etc, use the <a class="el" href="classOgre_1_1Material.html#a8c9ccac6e60241a1865ac211e3b203c8" title="Sets the kind of blending every pass has with the existing contents of the scene.">Material::setSceneBlending</a> method. </dd></dl>

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00139">139</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a1ea4fff299261c723f025337c513dc88"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::operator!=" ref="a1ea4fff299261c723f025337c513dc88" args="(const LayerBlendModeEx &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::LayerBlendModeEx::operator!= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1LayerBlendModeEx.html">LayerBlendModeEx</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00194">194</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4c678a65c3a32728622812d2784c2e6d"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::operator==" ref="a4c678a65c3a32728622812d2784c2e6d" args="(const LayerBlendModeEx &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::LayerBlendModeEx::operator== </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1LayerBlendModeEx.html">LayerBlendModeEx</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00162">162</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

<p>References <a class="el" href="OgreBlendMode_8h_source.html#l00156">alphaArg1</a>, <a class="el" href="OgreBlendMode_8h_source.html#l00158">alphaArg2</a>, <a class="el" href="OgreBlendMode_8h_source.html#l00143">blendType</a>, <a class="el" href="OgreBlendMode_8h_source.html#l00152">colourArg1</a>, <a class="el" href="OgreBlendMode_8h_source.html#l00154">colourArg2</a>, <a class="el" href="OgreBlendMode_8h_source.html#l00160">factor</a>, <a class="el" href="OgreBlendMode_8h_source.html#l00046">Ogre::LBT_COLOUR</a>, <a class="el" href="OgreBlendMode_8h_source.html#l00145">operation</a>, <a class="el" href="OgreBlendMode_8h_source.html#l00147">source1</a>, and <a class="el" href="OgreBlendMode_8h_source.html#l00149">source2</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a8af3aad5d2de939d0d9bff3049c82928"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::alphaArg1" ref="a8af3aad5d2de939d0d9bff3049c82928" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1LayerBlendModeEx.html#a8af3aad5d2de939d0d9bff3049c82928">Ogre::LayerBlendModeEx::alphaArg1</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Manual alpha value for manual source1. </p>

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00156">156</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBlendMode_8h_source.html#l00162">operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="a9dde2b63904e61319b175094f8fc67f0"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::alphaArg2" ref="a9dde2b63904e61319b175094f8fc67f0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1LayerBlendModeEx.html#a9dde2b63904e61319b175094f8fc67f0">Ogre::LayerBlendModeEx::alphaArg2</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Manual alpha value for manual source2. </p>

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00158">158</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBlendMode_8h_source.html#l00162">operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="ac2cb8de7b805400726882f7003a4bcda"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::blendType" ref="ac2cb8de7b805400726882f7003a4bcda" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Materials.html#ga1ae5925d36df27a6c3590536752264f8">LayerBlendType</a> <a class="el" href="classOgre_1_1LayerBlendModeEx.html#ac2cb8de7b805400726882f7003a4bcda">Ogre::LayerBlendModeEx::blendType</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The type of blending (colour or alpha) </p>

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00143">143</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBlendMode_8h_source.html#l00162">operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="a99adb8004759bf3825d934684ab8f171"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::colourArg1" ref="a99adb8004759bf3825d934684ab8f171" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ColourValue.html">ColourValue</a> <a class="el" href="classOgre_1_1LayerBlendModeEx.html#a99adb8004759bf3825d934684ab8f171">Ogre::LayerBlendModeEx::colourArg1</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Manual colour value for manual source1. </p>

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00152">152</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBlendMode_8h_source.html#l00162">operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="a6bd40927e40bcb2d6c4e077ebd56c24d"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::colourArg2" ref="a6bd40927e40bcb2d6c4e077ebd56c24d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ColourValue.html">ColourValue</a> <a class="el" href="classOgre_1_1LayerBlendModeEx.html#a6bd40927e40bcb2d6c4e077ebd56c24d">Ogre::LayerBlendModeEx::colourArg2</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Manual colour value for manual source2. </p>

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00154">154</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBlendMode_8h_source.html#l00162">operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="a71cee0ade264a82051913d5eb0fc4c40"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::factor" ref="a71cee0ade264a82051913d5eb0fc4c40" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1LayerBlendModeEx.html#a71cee0ade264a82051913d5eb0fc4c40">Ogre::LayerBlendModeEx::factor</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Manual blending factor. </p>

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00160">160</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBlendMode_8h_source.html#l00162">operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="afc151f1c17683cd99df776459df2c778"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::operation" ref="afc151f1c17683cd99df776459df2c778" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Materials.html#ga264ecab38a04d01e2c3158fa05ec1ee2">LayerBlendOperationEx</a> <a class="el" href="classOgre_1_1LayerBlendModeEx.html#afc151f1c17683cd99df776459df2c778">Ogre::LayerBlendModeEx::operation</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The operation to be applied. </p>

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00145">145</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBlendMode_8h_source.html#l00162">operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="a334818129ca44c1fbdba2b3b2813368a"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::source1" ref="a334818129ca44c1fbdba2b3b2813368a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Materials.html#gae2ad78de344f35307ce35157c175625e">LayerBlendSource</a> <a class="el" href="classOgre_1_1LayerBlendModeEx.html#a334818129ca44c1fbdba2b3b2813368a">Ogre::LayerBlendModeEx::source1</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The first source of colour/alpha. </p>

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00147">147</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBlendMode_8h_source.html#l00162">operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="a94eeae80ba84e9aa5271d317d48f2688"></a><!-- doxytag: member="Ogre::LayerBlendModeEx::source2" ref="a94eeae80ba84e9aa5271d317d48f2688" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Materials.html#gae2ad78de344f35307ce35157c175625e">LayerBlendSource</a> <a class="el" href="classOgre_1_1LayerBlendModeEx.html#a94eeae80ba84e9aa5271d317d48f2688">Ogre::LayerBlendModeEx::source2</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The second source of colour/alpha. </p>

<p>Definition at line <a class="el" href="OgreBlendMode_8h_source.html#l00149">149</a> of file <a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBlendMode_8h_source.html#l00162">operator==()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreBlendMode_8h_source.html">OgreBlendMode.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:54
</p>
</body>
</html>
